function C=corrm2m(qvw, vw, relevant, opt)
   
   if (~isfield(opt,'max_MxN'))
      opt.max_MxN=10;
   end;
      
   if (~isfield(opt,'max_tc'))
      opt.max_tc=600;
   end;
      
   query = sparse(qvw, 1, 1);   
   qids  = find(query);
   qtf   = full(query(qids));
   
   [sqvw iqvw] = sort(qvw);
   
   for i=1:numel(relevant)      
      dvw  = vw{relevant(i)};
      db   = sparse(dvw, 1, 1);   
      dids = find(db);
      dtf  = full(db(dids));
      
      [sdvw idvw] = sort(dvw);
      
      % find correspondences
      [ids,iq,id] = intersect(qids, dids);
      
      % find out cardinality of cartesian products
      MxN = qtf(iq).*dtf(id);
      
      % process one-to-one correspondences fast, each VW produces a pair in the result
      unique_vws = ids(MxN==1); 
      corrs = [iqvw(ismembc2(unique_vws, sqvw)); idvw(ismembc2(unique_vws, sdvw))];
      
      % ascending cardinality of corresponding VW
      [card, ord] = sort(MxN);
      
      % order ids in ascending order of cardinality, keep only cardinalities >1
      interesting = ids(ord(card>1 & card<opt.max_MxN & cumsum(card)<opt.max_tc));
      
      for j=interesting'
         [q d]=meshgrid(find(qvw==j), find(dvw==j));
         corrs=[corrs , [q(:)' ; d(:)']];
      end;
      if (size(corrs,2)>opt.max_tc)
        corrs(:, opt.max_tc+1:end)=[];
      end;
      C{i}=corrs;
   end;